import tornado.web
from torlite.model.muser import MUser
from pycate.model.info_model import MInfo
import config


class PycateBaseHandler(tornado.web.RequestHandler):
    def init_condition(self, sig):
        '''
        Initialize
        :param sig: sig for the collection name of MongoDB.
        :return: None
        '''
        self.muser = MUser()

        self.minfo = MInfo(sig)

        if self.get_current_user():
            self.userinfo = self.muser.get_by_id(self.get_current_user())
        else:
            self.userinfo = None

        self.template_dir_name = config.app_template_name

    def get_current_user(self):
        return self.get_secure_cookie("user")
